/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Policy holder.
 */
@ApiModel(description = "Policy holder.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class PolicyHolder {
  @SerializedName("title")
  private String title = null;

  @SerializedName("first_name")
  private String firstName = null;

  @SerializedName("middle_name")
  private String middleName = null;

  @SerializedName("last_name")
  private String lastName = null;

  @SerializedName("birth_date")
  private String birthDate = null;

  @SerializedName("external_informations")
  private ExternalInformations externalInformations = null;

  @SerializedName("spoken_language")
  private String spokenLanguage = null;

  @SerializedName("email")
  private String email = null;

  @SerializedName("phone")
  private Model34 phone = null;

  @SerializedName("address")
  private Model35 address = null;

  @SerializedName("is_policy_beneficiary")
  private Boolean isPolicyBeneficiary = null;

  public PolicyHolder title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Civility (Mr, Ms, Miss, Doctor, Professor). Expected values:(MR, MRS, MISS, DR, PR)
   * @return title
  **/
  @ApiModelProperty(example = "MR", required = true, value = "Civility (Mr, Ms, Miss, Doctor, Professor). Expected values:(MR, MRS, MISS, DR, PR)")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public PolicyHolder firstName(String firstName) {
    this.firstName = firstName;
    return this;
  }

   /**
   * First name.
   * @return firstName
  **/
  @ApiModelProperty(required = true, value = "First name.")
  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public PolicyHolder middleName(String middleName) {
    this.middleName = middleName;
    return this;
  }

   /**
   * Middle name.
   * @return middleName
  **/
  @ApiModelProperty(value = "Middle name.")
  public String getMiddleName() {
    return middleName;
  }

  public void setMiddleName(String middleName) {
    this.middleName = middleName;
  }

  public PolicyHolder lastName(String lastName) {
    this.lastName = lastName;
    return this;
  }

   /**
   * Last name.
   * @return lastName
  **/
  @ApiModelProperty(required = true, value = "Last name.")
  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public PolicyHolder birthDate(String birthDate) {
    this.birthDate = birthDate;
    return this;
  }

   /**
   * Birth date - ISO 8601 format (YYYY-MM-DD).
   * @return birthDate
  **/
  @ApiModelProperty(example = "1990-04-25", required = true, value = "Birth date - ISO 8601 format (YYYY-MM-DD).")
  public String getBirthDate() {
    return birthDate;
  }

  public void setBirthDate(String birthDate) {
    this.birthDate = birthDate;
  }

  public PolicyHolder externalInformations(ExternalInformations externalInformations) {
    this.externalInformations = externalInformations;
    return this;
  }

   /**
   * Get externalInformations
   * @return externalInformations
  **/
  @ApiModelProperty(value = "")
  public ExternalInformations getExternalInformations() {
    return externalInformations;
  }

  public void setExternalInformations(ExternalInformations externalInformations) {
    this.externalInformations = externalInformations;
  }

  public PolicyHolder spokenLanguage(String spokenLanguage) {
    this.spokenLanguage = spokenLanguage;
    return this;
  }

   /**
   * Spoken language, IANA language codification.
   * @return spokenLanguage
  **/
  @ApiModelProperty(required = true, value = "Spoken language, IANA language codification.")
  public String getSpokenLanguage() {
    return spokenLanguage;
  }

  public void setSpokenLanguage(String spokenLanguage) {
    this.spokenLanguage = spokenLanguage;
  }

  public PolicyHolder email(String email) {
    this.email = email;
    return this;
  }

   /**
   * Email address.
   * @return email
  **/
  @ApiModelProperty(example = "john.doe@unknown.com", required = true, value = "Email address.")
  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public PolicyHolder phone(Model34 phone) {
    this.phone = phone;
    return this;
  }

   /**
   * Get phone
   * @return phone
  **/
  @ApiModelProperty(value = "")
  public Model34 getPhone() {
    return phone;
  }

  public void setPhone(Model34 phone) {
    this.phone = phone;
  }

  public PolicyHolder address(Model35 address) {
    this.address = address;
    return this;
  }

   /**
   * Get address
   * @return address
  **/
  @ApiModelProperty(value = "")
  public Model35 getAddress() {
    return address;
  }

  public void setAddress(Model35 address) {
    this.address = address;
  }

  public PolicyHolder isPolicyBeneficiary(Boolean isPolicyBeneficiary) {
    this.isPolicyBeneficiary = isPolicyBeneficiary;
    return this;
  }

   /**
   * Indicates if the policy holder is also a policy beneficiary.
   * @return isPolicyBeneficiary
  **/
  @ApiModelProperty(example = "false", required = true, value = "Indicates if the policy holder is also a policy beneficiary.")
  public Boolean isIsPolicyBeneficiary() {
    return isPolicyBeneficiary;
  }

  public void setIsPolicyBeneficiary(Boolean isPolicyBeneficiary) {
    this.isPolicyBeneficiary = isPolicyBeneficiary;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PolicyHolder policyHolder = (PolicyHolder) o;
    return Objects.equals(this.title, policyHolder.title) &&
        Objects.equals(this.firstName, policyHolder.firstName) &&
        Objects.equals(this.middleName, policyHolder.middleName) &&
        Objects.equals(this.lastName, policyHolder.lastName) &&
        Objects.equals(this.birthDate, policyHolder.birthDate) &&
        Objects.equals(this.externalInformations, policyHolder.externalInformations) &&
        Objects.equals(this.spokenLanguage, policyHolder.spokenLanguage) &&
        Objects.equals(this.email, policyHolder.email) &&
        Objects.equals(this.phone, policyHolder.phone) &&
        Objects.equals(this.address, policyHolder.address) &&
        Objects.equals(this.isPolicyBeneficiary, policyHolder.isPolicyBeneficiary);
  }

  @Override
  public int hashCode() {
    return Objects.hash(title, firstName, middleName, lastName, birthDate, externalInformations, spokenLanguage, email, phone, address, isPolicyBeneficiary);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PolicyHolder {\n");
    
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    firstName: ").append(toIndentedString(firstName)).append("\n");
    sb.append("    middleName: ").append(toIndentedString(middleName)).append("\n");
    sb.append("    lastName: ").append(toIndentedString(lastName)).append("\n");
    sb.append("    birthDate: ").append(toIndentedString(birthDate)).append("\n");
    sb.append("    externalInformations: ").append(toIndentedString(externalInformations)).append("\n");
    sb.append("    spokenLanguage: ").append(toIndentedString(spokenLanguage)).append("\n");
    sb.append("    email: ").append(toIndentedString(email)).append("\n");
    sb.append("    phone: ").append(toIndentedString(phone)).append("\n");
    sb.append("    address: ").append(toIndentedString(address)).append("\n");
    sb.append("    isPolicyBeneficiary: ").append(toIndentedString(isPolicyBeneficiary)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

